package k.ld34;

import k.lib.graphics.DisplayObject;

import k.ld34.entities.Entity;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class Stage extends k.lib.graphics.Stage<Entity> {
	public static var GAME_POSITION_X:Int = 0;
	public static var GAME_POSITION_Y:Int = 0;

	public var back:DisplayObject;
	public var safe:DisplayObject;
	public var asteroid:DisplayObject;
	public var midway:DisplayObject;
	public var enemies:DisplayObject;
	public var bullets:DisplayObject;
	public var player:DisplayObject;
	public var effects:DisplayObject;
	public var front:DisplayObject;

	public function new() {
		super(-1);

		back = new DisplayObject(-1);
		back.x = GAME_POSITION_X; back.y = GAME_POSITION_Y;
		addChild(back);

		safe = new DisplayObject(-1);
		safe.x = GAME_POSITION_X; safe.y = GAME_POSITION_Y;
		addChild(safe);

		asteroid = new DisplayObject(-1);
		asteroid.x = GAME_POSITION_X; asteroid.y = GAME_POSITION_Y;
		addChild(asteroid);

		midway = new DisplayObject(-1);
		midway.x = GAME_POSITION_X; midway.y = GAME_POSITION_Y;
		addChild(midway);

		enemies = new DisplayObject(-1);
		enemies.x = GAME_POSITION_X; enemies.y = GAME_POSITION_Y;
		addChild(enemies);

		bullets = new DisplayObject(-1);
		bullets.x = GAME_POSITION_X; bullets.y = GAME_POSITION_Y;
		addChild(bullets);

		player = new DisplayObject(-1);
		player.x = GAME_POSITION_X; player.y = GAME_POSITION_Y;
		addChild(player);

		effects = new DisplayObject(-1);
		effects.x = GAME_POSITION_X; effects.y = GAME_POSITION_Y;
		addChild(effects);

		front = new DisplayObject(-1);
		addChild(front);
	}

	public function switchLayer(e:Entity, from:DisplayObject, to:DisplayObject):Void {
		from.removeChild(e);
		to.addChild(e);
	}

	override public function addEntity(e:Entity):Int {
		switch(e.group) {
			case "player":
			return player.addChild(e);

			case "player-bullet":
			return bullets.addChild(e);

			case "player-misc":
			player.unshiftChild(e);
			return 0;

			case "stars":
			return back.addChild(e);

			case "asteroid":
			return asteroid.addChild(e);

			case "effects":
			return effects.addChild(e);

			case "foes":
			return enemies.addChild(e);

			case "foes-bullet":
			return bullets.addChild(e);

			default:
			return -1;
		}
	}

	override public function removeEntity(e:Entity):Void {
		switch(e.group) {
			case "player":
			player.removeChild(e);
			midway.removeChild(e);
			safe.removeChild(e);

			case "player-bullet":
			bullets.removeChild(e);

			case "player-misc":
			player.removeChild(e);

			case "stars":
			back.removeChild(e);

			case "asteroid":
			asteroid.removeChild(e);

			case "effects":
			effects.removeChild(e);

			case "foes":
			enemies.removeChild(e);

			case "foes-bullet":
			bullets.removeChild(e);

			default:
		}
	}

	public inline function getEntities(g:String):Array<Entity> {
		// TODO: select layer from g
		var layer:DisplayObject = enemies;

		var arr:Array<Entity> = new Array<Entity>();
		for (e in layer.children) {
			if (e.group == g) {
				arr.push(cast(e, Entity));
			}
		}
		return arr;
	}
}
