package k.ld34.effects;

import k.ld34.entities.Entity;

class Star extends Entity {
	private var curr:Int;

	public function new(parent:Stage) {
		super(parent, "stars");

		curr = 0;
		tile_id = -1;
		tile_name = "star-" + curr;
		has_preupdate = true;

		chooseCoordinates();
	}

	private function chooseCoordinates():Void {
		var x:Int = Main.random.intBelow(Main.GAME_WIDTH);
		var y:Int = Main.random.intBelow(Main.GAME_HEIGHT);

		if (validateCoordinates(x, y)) {
			setCoordinates(x, y);
		} else {
			chooseCoordinates();
		}
	}

	private function validateCoordinates(x:Int, y:Int):Bool {
		var stars:Array<Star> = Main.stars;
		var threshold:Int = 30;
		for (s in stars) {
			var dist:Float = Math.abs(s.x - x) + Math.abs(s.y - y);
			if (dist < threshold) return false;
		}
		return true;
	}

	override private inline function preUpdate():Void {
		if (Main.kframe % 2 == 0) y++;
		if (Main.kframe % 5 != 2) return;

		curr++;
		if (curr > 5) {
			Main.stars.remove(this);
			return destroy();
		}

		tile_id = -1;
		tile_name = "star-" + curr;
	}
}
