package k.ld34.entities;

import k.lib.graphics.DisplayObject;

import k.lib.gconsole.GameConsole;

class AsteroidBelt extends Entity {
	private static inline var SCROLL_SPEED:Int = 1;

	public function new(stage:Stage) {
		super(stage, "asteroid");

		has_preupdate = true;

		var y:Int = -160;
		while (y < Main.GAME_HEIGHT + 32) {
			createLine(y);
			y += 32;
		}
	}

	override private function preUpdate():Void {
		if (Main.kframe % 2 != 0) return;

		var minY:Int = Main.GAME_HEIGHT;
		for (line in children) {
			line.y += SCROLL_SPEED;
			if (line.y < minY) minY = line.y;
		}

		for (line in children) {
			if (line.y > Main.GAME_HEIGHT + 32) {
				removeChild(line);
				createLine(minY - 32);
			}
		}
	}

	private function createLine(y:Int):Void {
		var line:AsteroidLine = new AsteroidLine(y);
		addChild(line);
	}
}

class AsteroidLine extends DisplayObject {

	public function new(startY:Int) {
		super(-1);
		y = startY;
		var x:Int = -32;
		while (x < Main.GAME_WIDTH + 32) {
			var asteroid:DisplayObject = new DisplayObject("asteroid");
			asteroid.x = x;
			asteroid.y = 0;
			addChild(asteroid);
			x += 32;
		}
	}
}
