package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;

import k.ld34.entities.Entity;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class Bullet extends Entity {
	private var START_SPEED:Float;
	private var SPEED_INCREASE:Float;
	private var MAX_SPEED:Float;
	private var dir:Int;

	public function new(parent:Stage, group:String, suffix:String, speeds:Array<Float>) {
		super(parent, group + "-bullet");

		tile_id = -1;
		tile_name = group + "-bullet";
		if (suffix != "") tile_name += "-" + suffix;

		radius = 2;
		health = 1;
		has_preupdate = true;

		START_SPEED = speeds[0];
		SPEED_INCREASE = speeds[1];
		MAX_SPEED = speeds[2];

		dir = (group == "foes") ? 1 : -1;
		dy = dir * START_SPEED;
	}

	override private function preUpdate():Void {
		if (y < 0 || y > Main.GAME_HEIGHT + 5) {
			_parent.removeEntity(this);
		} else {
			dy += dir * SPEED_INCREASE;
			if (dir == -1 && dy < dir * MAX_SPEED) dy = dir * MAX_SPEED;
			else if (dir == 1 && dy > dir * MAX_SPEED) dy = dir * MAX_SPEED;
		}
	}
}
