package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;

import k.ld34.entities.Entity;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class ExpendingBullet extends Entity {
	private var START_SPEED:Float;
	private var SPEED_INCREASE:Float;
	private var MAX_SPEED:Float;
	private var angle:Float;
	private var speed:Float;
	private var posRadius:Float;
	private var rotateSpeed:Float;
	private var shipX:Int;
	private var shipY:Int;

	public function new(parent:Stage, ship:Ship, angle:Float, posRadius:Int, speed:Float, ?rotateSpeed:Float = 0) {
		super(parent, "foes-bullet");
		this.shipX = ship.x;
		this.shipY = ship.y;
		this.angle = angle;
		this.posRadius = posRadius;
		this.speed = speed;
		this.rotateSpeed = rotateSpeed;

		tile_id = -1;
		tile_name = "foes-bullet-circle";

		radius = 2;
		health = 1;
		has_preupdate = true;
	}

	override private function preUpdate():Void {
		if (y < -10 || y > Main.GAME_HEIGHT + 10 || x < -10 || x > Main.GAME_WIDTH + 10) {
			_parent.removeEntity(this);
		} else {
			if (rotateSpeed != 0) angle += rotateSpeed;
			posRadius += speed;
			var x:Int = Std.int(shipX + Math.cos(angle) * posRadius);
			var y:Int = Std.int(shipY - Math.sin(angle) * posRadius);
			setCoordinates(x, y);
		}
	}
}
