package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;

import k.ld34.entities.Entity;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class HealthBar extends Entity {
	private static inline var POSY:Int = 16;
	private var ship:Player;
	private var lastValue:Int;

	public function new(parent:Stage, ship:Player) {
		super(parent, "player-misc");
		this.ship = ship;

		tile_id = -1;
		tile_name = "healthbar-10";
		lastValue = 100;
		has_preupdate = true;
	}

	override private inline function preUpdate():Void {
		if (x != ship.x || y != ship.y + POSY) {
			var dy:Int = 0;
			if (ship.currLayer == "mid") dy -= 2;
			else if (ship.currLayer == "safe") dy -= 3;
			setCoordinates(ship.x, ship.y + POSY + dy);
			Entity.needsUpdate = true;
		}

		var newValue:Int = Std.int(100 * ship.energy / Player.MAX_ENERGY);
		if (newValue != lastValue) {
			lastValue = newValue;
			tile_id = -1;
			tile_name = "healthbar-" + Std.int(lastValue/10);
			Entity.needsUpdate = true;
		}
	}
}
