package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;

import k.ld34.entities.Entity;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class MaxiBullet extends Entity {
	private var START_SPEED:Float;
	private var SPEED_INCREASE:Float;
	private var MAX_SPEED:Float;
	private var dir:Int;

	public function new(parent:Stage) {
		super(parent, "player");

		tile_id = -1;
		tile_name = "maxi-bullet";

		radius = 12;
		health = 999;
		attack = 999;
		has_preupdate = true;

		var speeds:Array<Float> = [0.004, 0.003, 0.04];
		START_SPEED = speeds[0];
		SPEED_INCREASE = speeds[1];
		MAX_SPEED = speeds[2];

		dy = -1 * START_SPEED;
	}

	override private function preUpdate():Void {
		if (y < -10) {
			_parent.removeEntity(this);
		} else {
			dy += -1 * SPEED_INCREASE;
			if (dy < -1 * MAX_SPEED) dy = -1 * MAX_SPEED;
		}
	}
}
