package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class ShipCShield extends Ship {
	private var angle:Float;
	private var posRadius:Float;
	private var ship:Ship;
	private var color:String;

	public function new(parent:Stage, ship:Ship, color:String, angle:Float) {
		super(parent);
		this.ship = ship;
		this.color = color;

		tile_id = -1;
		tile_name = "ship-shield-" + color + "-base";
		points = 200;

		shootingRate = 0; // Disable default shooting

		radius = 6;
		health = 10;
		if (color == "red") health = 25;

		this.angle = angle;
		posRadius = 14;
	}

	override private function _preUpdate():Void {
		angle += 0.035;
		var x:Int = Std.int(ship.x + Math.cos(angle) * posRadius);
		var y:Int = Std.int(ship.y - Math.sin(angle) * posRadius);
		setCoordinates(x, y);
	}

}
