package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;
import k.lib.sound.SoundManager;

import k.ld34.effects.Shot;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class ShipD extends Ship {
	public function new(parent:Stage, diff:Int, x:Int, y:Int) {
		super(parent);

		tile_id = -1;
		tile_name = "ship-d-base";
		baseTile = "ship-d";
		hasMove = true;
		points = 250;

		radius = 6;
		health = 6;
		maxSpeed = 0.03;
		shootingRate = 200 - Std.int(Math.min(diff * 5, 75));
		frame = Main.random.intBetween(0, 50);
		setCoordinates(x, y);
	}

	override private function _preUpdate():Void {
		// TODO: movement

	}

	override private function shoot():Void {
		if (Main.hasLost) return;

		// Display effect
		var shot:Shot = new Shot(_parent, "ship-d", 2);
		shot.setCoordinates(x, y);

		var bulletSpeeds:Array<Float> = [0.002, 0.003, 0.025];
		var bullet = new Bullet(_parent, "foes", "", bulletSpeeds); // TODO: suffix
		bullet.setCoordinates(x, y + 8);
	}

}
