package k.ld34.entities;

import k.lib.graphics.DisplayObject;
import k.lib.utils.KMath;
import k.lib.utils.Ease;

#if DEBUG
import k.lib.gconsole.GameConsole;
#end

class ShipG extends Ship {
	private var shield1:ShipCShield;
	private var shield2:ShipCShield;
	private var shield3:ShipCShield;
	private var shield4:ShipCShield;

	public function new(parent:Stage, diff:Int) {
		shield1 = new ShipCShield(parent, this, "red", 0);
		shield2 = new ShipCShield(parent, this, "red", 1.57);
		shield3 = new ShipCShield(parent, this, "red", 3.14);
		shield4 = new ShipCShield(parent, this, "red", 4.71);
		super(parent);

		tile_id = -1;
		tile_name = "ship-g-base";
		points = 2000;

		shootingRate = 0;
		radius = 10;
		health = 25;
		maxSpeed = 0.045;

		var x:Int = Std.int(Main.GAME_WIDTH / 2);
		var y:Int = -20;
		setCoordinates(x, y);

		var destX:Int = Main.random.intBetween(10, Main.GAME_WIDTH - 10);
		var destY:Int = Main.random.intBetween(10, 40);
		setDestination(destX, destY, stopMoving);
	}

	override public function destroy():Void {
		shield1.destroy();
		shield2.destroy();
		shield3.destroy();
		shield4.destroy();
		super.destroy();
	}

	private function stopMoving(e:Entity):Void {
		dx = dy = 0;
	}

	override private function _preUpdate():Void {
		if (frame % 360 == 0) {
			var destX:Int = Main.random.intBetween(10, Main.GAME_WIDTH - 10);
			var destY:Int = Main.random.intBetween(10, 40);
			setDestination(destX, destY, stopMoving);
		}
	}

}
