package k.ld34.waves;

import k.ld34.Stage;
import k.ld34.entities.Entity;

import k.lib.gconsole.GameConsole;

@:generic
class LineWave<T:{
	var maxposx:Int;
	var minposx:Int;
	function new(parent:Stage, diff:Int, x:Int, y:Int):Void;
	function setDestination(x:Float, y:Float, ?cb:Entity->Void):Void;
}> extends Wave {
	public function new(stage:Stage, diff:Int, dir:Int) {
		super(stage, diff);

		var nShips:Int = 4;
		if (diff > 2) nShips++;
		if (diff > 3) nShips++;
		if (diff > 5) nShips++;

		var posx:Int = dir == 1 ? -150 : Main.GAME_WIDTH + 150;
		var posy:Int = Main.random.intBetween(20, 70);

		for (i in 0...nShips) {
			var ship:T = new T(stage, diff, posx, posy);
			if (dir == 1) ship.maxposx = Main.GAME_WIDTH + 20;
			else ship.minposx = -20;
			ship.setDestination(Main.GAME_WIDTH - posx, posy);
			posx += dir * 16;
		}
	}
}
