package k.ld34.waves;

import k.ld34.Stage;
import k.ld34.entities.Entity;

import k.lib.gconsole.GameConsole;

typedef Destination = {
	x:Int,
	y:Int
}

@:generic
class SnakeWave<T:{
	var data:Dynamic;
	function new(parent:Stage, diff:Int, x:Int, y:Int):Void;
	function setDestination(x:Float, y:Float, ?cb:Entity->Void):Void;
}> extends Wave {
	private var dests:Array<Destination>;

	public function new(stage:Stage, diff:Int) {
		super(stage, diff);

		var diffFactor:Int = 0;
		if (diff > 3) diffFactor++;
		if (diff > 6) diffFactor++;
		if (diff > 10) diffFactor++;

		var nShips:Int = Main.random.intBetween(5 + diffFactor, 8 + diffFactor);
		var posx:Int = Main.random.intBetween(0, Main.GAME_WIDTH);
		var posy:Int = -20;
		dests = [];

		for (i in 0...nShips) {
			var ship:T = new T(stage, diff, posx, posy);
			ship.data = 0;
			ship.setDestination(posx, 30, nextDestination);
			posy -= 16;
		}

		posy = 30;
		var lastMoveH:Bool = false;
		var nDestinations:Int = 4; //Main.random.intBetween(4, 7);
		for (i in 0...nDestinations) {
			if (lastMoveH) {
				posy += Main.random.intBetween(25, 35);
			} else {
				var dir = posx > 50 ? -1 : 1;
				posx += Main.random.intBetween(60, Main.GAME_WIDTH) * dir;
			}

			dests.push({x: posx, y: posy});
			lastMoveH = !lastMoveH;
		}

		var dir = posx > Main.GAME_WIDTH / 2 ? -1 : 1;
		posx += Main.GAME_WIDTH * 2 * dir;
		dests.push({x: posx, y: posy});
	}

	private function nextDestination(ship:Entity):Void {
		var step:Int = Std.int(ship.data);
		if (step >= dests.length) {
			ship.destroy();
			return;
		}

		ship.setDestination(dests[step].x, dests[step].y, nextDestination);
		ship.data++;
	}
}
